## rustc 1.16.0+dfsg1

=== src/test/run-make/symbol-visibility/Makefile ===
include ../tools.mk

ifdef IS_WINDOWS
# Do nothing on MSVC.
# On MINGW the --version-script, --dynamic-list, and --retain-symbol args don't
# seem to work reliably.
all:
	exit 0
else

NM=nm -D
DYLIB_EXT=so
CDYLIB_NAME=liba_cdylib.so
RDYLIB_NAME=liba_rust_dylib.so
EXE_NAME=an_executable

ifeq ($(UNAME),Darwin)
NM=nm -gU
DYLIB_EXT=dylib
CDYLIB_NAME=liba_cdylib.dylib
RDYLIB_NAME=liba_rust_dylib.dylib
EXE_NAME=an_executable
endif

all:
	$(RUSTC) an_rlib.rs
	$(RUSTC) a_cdylib.rs
	$(RUSTC) a_rust_dylib.rs
	$(RUSTC) an_executable.rs

	# Check that a cdylib exports its public #[no_mangle] functions
	[ "$$($(NM) $(TMPDIR)/$(CDYLIB_NAME) | grep -c public_c_function_from_cdylib)" -eq "1" ]
	# Check that a cdylib exports the public #[no_mangle] functions of dependencies
	[ "$$($(NM) $(TMPDIR)/$(CDYLIB_NAME) | grep -c public_c_function_from_rlib)" -eq "1" ]
	# Check that a cdylib DOES NOT export any public Rust functions
	[ "$$($(NM) $(TMPDIR)/$(CDYLIB_NAME) | grep -c _ZN.*h.*E)" -eq "0" ]

	# Check that a Rust dylib exports its monomorphic functions
	[ "$$($(NM) $(TMPDIR)/$(RDYLIB_NAME) | grep -c public_c_function_from_rust_dylib)" -eq "1" ]
	[ "$$($(NM) $(TMPDIR)/$(RDYLIB_NAME) | grep -c _ZN.*public_rust_function_from_rust_dylib.*E)" -eq "1" ]

	# Check that a Rust dylib exports the monomorphic functions from its dependencies
	[ "$$($(NM) $(TMPDIR)/$(RDYLIB_NAME) | grep -c public_c_function_from_rlib)" -eq "1" ]
	[ "$$($(NM) $(TMPDIR)/$(RDYLIB_NAME) | grep -c public_rust_function_from_rlib)" -eq "1" ]

	# Check that an executable does not export any dynamic symbols
	[ "$$($(NM) $(TMPDIR)/$(EXE_NAME) | grep -c public_c_function_from_rlib)" -eq "0" ]
	[ "$$($(NM) $(TMPDIR)/$(EXE_NAME) | grep -c public_rust_function_from_exe)" -eq "0" ]

endif

=== src/test/run-make/target-specs/Makefile ===
-include ../tools.mk
all:
	$(RUSTC) foo.rs --target=my-awesome-platform.json --crate-type=lib --emit=asm
	grep -q -v morestack < $(TMPDIR)/foo.s
	$(RUSTC) foo.rs --target=my-invalid-platform.json 2>&1 | grep -q "Error loading target specification"
	$(RUSTC) foo.rs --target=my-incomplete-platform.json 2>&1 | grep 'Field llvm-target'
	RUST_TARGET_PATH=. $(RUSTC) foo.rs --target=my-awesome-platform --crate-type=lib --emit=asm
	RUST_TARGET_PATH=. $(RUSTC) foo.rs --target=x86_64-unknown-linux-gnu --crate-type=lib --emit=asm
	$(RUSTC) -Z unstable-options --target=my-awesome-platform.json --print target-spec-json > $(TMPDIR)/test-platform.json && $(RUSTC) -Z unstable-options --target=$(TMPDIR)/test-platform.json --print target-spec-json | diff -q $(TMPDIR)/test-platform.json -

=== debian/changelog ===
rustc (1.16.0+dfsg1-1~exp1ubuntu1) zesty; urgency=medium

  * Merge with Debian; remaining changes:
    - Bootstrap using the rustc version in the archive, on all architectures.
    - Work around a GCC 4.8 ICE on AArch64.
    - Use alternative build dependencies on cmake3 and binutils-2.26 for
      builds on 14.04 LTS (trusty).
    - debian/make_orig-dl_tarball.sh: Include all Ubuntu architectures.
    - debian/rules: Ignore test results for now.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 17 Mar 2017 14:47:24 +0100

rustc (1.16.0+dfsg1-1~exp1) experimental; urgency=medium

  * New upstream release
  * u-ignoretest-jemalloc.patch removed (applied upstream)

 -- Sylvestre Ledru <sylvestre@debian.org>  Fri, 17 Mar 2017 10:33:46 +0100

rustc (1.15.1+dfsg1-1~exp1ubuntu1) zesty; urgency=medium

  * Merge with Debian; remaining changes:
    - Bootstrap using the rustc version in the archive, on all architectures.
    - Work around a GCC 4.8 ICE on AArch64.
    - Use alternative build dependencies on cmake3, binutils-2.26, antlr and
      default-jdk for builds on 14.04 LTS (trusty).
    - debian/make_orig-dl_tarball.sh: Include all Ubuntu architectures.
    - debian/rules: Ignore test results for now.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 01 Mar 2017 14:29:01 +0100

rustc (1.15.1+dfsg1-1~exp3) experimental; urgency=medium

  * Ignore atomic-lock-free tests on armhf.
  * Update ignoretest-armhf_03.patch for newer 1.15.1 behaviour.
  * Tidy up some other patches to do with ignoring tests.

 -- Ximin Luo <infinity0@debian.org>  Sun, 12 Mar 2017 04:15:33 +0100

rustc (1.15.1+dfsg1-1~exp2) experimental; urgency=medium

  * Update armhf ignoretest patch.
  * Bootstrap armhf. (Closes: #809316, #834003)
  * Bootstrap ppc4el. (Closes: #839643)
  * Fix rust-lldb symlink. (Closes: #850639)

 -- Ximin Luo <infinity0@debian.org>  Thu, 02 Mar 2017 23:01:26 +0100

=== debian/control ===
Source: rustc
Section: devel
Priority: extra
Maintainer: Rust Maintainers <pkg-rust-maintainers@lists.alioth.debian.org>
Uploaders: Jordan Justen <jordan.l.justen@intel.com>,
 Luca Bruno <lucab@debian.org>,
 Sylvestre Ledru <sylvestre@debian.org>,
 Angus Lees <gus@debian.org>,
 Ximin Luo <infinity0@debian.org>
Build-Depends: debhelper (>= 9),
               dpkg-dev (>= 1.17.14),
               rustc (>= 1.15.0+dfsg) <!pkg.rustc.dlstage0>,
               rustc (<= 1.16.1++) <!pkg.rustc.dlstage0>,
               autotools-dev,
               binutils-2.26 | binutils (>= 2.26),
               cmake3 | cmake,
               curl,
               gperf,
               libedit-dev,
               llvm-3.9-dev (>= 1:3.9-5),
               llvm-3.9-tools (>= 1:3.9-5),
               python,
               zlib1g-dev,
               nodejs <!nocheck>,
               valgrind <!nocheck>,
               git <!nocheck>,
               procps <!nocheck>,
# the tests require the docs to be built, which requires jquery
               libjs-jquery <!nocheck>,
# below are optional tools even for 'make check'
               antlr4 <!nocheck> | antlr <!nocheck>,
               bison <!nocheck>,
               flex <!nocheck>,
# TODO: broken; see https://github.com/rust-lang/rust/issues/39838; re-enable when that is fixed
#               gdb <!nocheck>,
               default-jdk-headless <!nocheck> | default-jdk <!nocheck>,
Build-Depends-Indep: libjs-jquery <!nodoc>,
                     pandoc (>= 1.9),
                     po4a,
                     texlive-xetex,
                     texlive-latex-base,
                     texlive-generic-recommended,
                     texlive-fonts-recommended,
                     lmodern
Standards-Version: 3.9.8
Homepage: http://www.rust-lang.org/
Vcs-Git: https://anonscm.debian.org/git/pkg-rust/rust.git
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-rust/rust.git

Package: rustc
Architecture: any
Multi-Arch: foreign
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}, libstd-rust-dev (= ${binary:Version}),
 gcc, libc-dev, libjs-jquery, binutils (>= 2.26)
Recommends: rust-gdb | rust-lldb
Suggests: rust-doc
Description: Rust systems programming language
 Rust is a curly-brace, block-structured expression language.  It
 visually resembles the C language family, but differs significantly
 in syntactic and semantic details.  Its design is oriented toward
 concerns of "programming in the large", that is, of creating and
 maintaining boundaries - both abstract and operational - that
 preserve large-system integrity, availability and concurrency.
 .
 It supports a mixture of imperative procedural, concurrent actor,
 object-oriented and pure functional styles.  Rust also supports
 generic programming and meta-programming, in both static and dynamic
 styles.

Package: libstd-rust-1.16
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Rust standard libraries
 Rust is a curly-brace, block-structured expression language.  It
 visually resembles the C language family, but differs significantly
 in syntactic and semantic details.  Its design is oriented toward
 concerns of "programming in the large", that is, of creating and
 maintaining boundaries - both abstract and operational - that
 preserve large-system integrity, availability and concurrency.
 .
 It supports a mixture of imperative procedural, concurrent actor,
 object-oriented and pure functional styles.  Rust also supports
 generic programming and meta-programming, in both static and dynamic
 styles.
 .
 This package contains the standard Rust libraries, built as dylibs.

Package: libstd-rust-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, libstd-rust-1.16 (= ${binary:Version})
Description: Rust standard libraries - development files
 Rust is a curly-brace, block-structured expression language.  It
 visually resembles the C language family, but differs significantly
 in syntactic and semantic details.  Its design is oriented toward
 concerns of "programming in the large", that is, of creating and
 maintaining boundaries - both abstract and operational - that
 preserve large-system integrity, availability and concurrency.
 .
 It supports a mixture of imperative procedural, concurrent actor,
 object-oriented and pure functional styles.  Rust also supports
 generic programming and meta-programming, in both static and dynamic
 styles.
 .
 This package contains development files necessary to use the standard
 Rust libraries.

Package: rust-gdb
Architecture: all
Depends: gdb, ${misc:Depends}
Suggests: gdb-doc
Replaces: rustc (<< 1.1.0+dfsg1-1)
Description: Rust debugger (gdb)
 Rust is a curly-brace, block-structured expression language.  It
 visually resembles the C language family, but differs significantly
 in syntactic and semantic details.  Its design is oriented toward
 concerns of "programming in the large", that is, of creating and
 maintaining boundaries - both abstract and operational - that
 preserve large-system integrity, availability and concurrency.
 .
 It supports a mixture of imperative procedural, concurrent actor,
 object-oriented and pure functional styles.  Rust also supports
 generic programming and meta-programming, in both static and dynamic
 styles.
 .
 This package contains pretty printers and a wrapper script for
 invoking gdb on rust binaries.

Package: rust-lldb
Architecture: all
# When updating, also update rust-lldb.links
Depends: lldb-3.9, ${misc:Depends}, python-lldb-3.9
Replaces: rustc (<< 1.1.0+dfsg1-1)
Description: Rust debugger (lldb)
 Rust is a curly-brace, block-structured expression language.  It
 visually resembles the C language family, but differs significantly
 in syntactic and semantic details.  Its design is oriented toward
 concerns of "programming in the large", that is, of creating and
 maintaining boundaries - both abstract and operational - that
 preserve large-system integrity, availability and concurrency.
 .
 It supports a mixture of imperative procedural, concurrent actor,
 object-oriented and pure functional styles.  Rust also supports
 generic programming and meta-programming, in both static and dynamic
 styles.
 .
 This package contains pretty printers and a wrapper script for
 invoking lldb on rust binaries.

Package: rust-doc
Section: doc
Architecture: all
Build-Profiles: <!nodoc>
Depends: ${misc:Depends}, libjs-jquery
Description: Rust systems programming language - Documentation
 Rust is a curly-brace, block-structured expression language.  It
 visually resembles the C language family, but differs significantly
 in syntactic and semantic details.  Its design is oriented toward
 concerns of "programming in the large", that is, of creating and
 maintaining boundaries - both abstract and operational - that
 preserve large-system integrity, availability and concurrency.
 .
 It supports a mixture of imperative procedural, concurrent actor,
 object-oriented and pure functional styles.  Rust also supports
 generic programming and meta-programming, in both static and dynamic
 styles.
 .
 This package contains the Rust tutorial, language reference and
 standard library documentation.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

include /usr/share/dpkg/pkg-info.mk
include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/buildflags.mk
#RUSTFLAGS = -C link-args="$(LDFLAGS)"
# temporary workaround for https://github.com/rust-lang/rust/issues/31529
# this will FAIL if LDFLAGS itself contains shell-interpreted chars beyond
# unquoted spaces (that addprefix works around the failure of)
RUSTFLAGS = $(addprefix -C link-args=,$(LDFLAGS))
export CFLAGS CXXFLAGS CPPFLAGS LDFLAGS RUSTFLAGS

# see https://github.com/rust-lang/rust/issues/37320
# it should be possible to remove this in the next Debian release
export MALLOC_CONF = lg_dirty_mult:-1

# Defines DEB_*_RUST_TYPE triples
include debian/architecture.mk

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# When using sudo pbuilder, this will cause mk/install.mk to run sudo,
# but we don't need sudo as a build-dep for the package if we unexport
# the SUDO_USER variable.
unexport SUDO_USER

# src/rt/miniz.c (incorrectly) triggers -Wmisleading-indentation with
# gcc-6.  See bug #811573.
CFLAGS += -Wno-misleading-indentation

# Release type (one of beta, stable or nightly)
RELEASE_CHANNEL := stable
# See also ./build-preview-dsc.sh for a script that builds a beta/nightly .dsc
# out of this packaging. Furthermore, if the build breaks after importing a new
# upstream stable release, check the do_temporary_fixup function in that file
# to see if we already know what fix to make.

DEB_DESTDIR := $(CURDIR)/debian/tmp

RUST_VERSION := $(shell dpkg-parsechangelog --show-field Version | sed -re 's/([^.]+)\.([^.]+)\..*/\1.\2/')
LIBSTD_PKG := libstd-rust-$(RUST_VERSION)

# These are the normal build flags
DEB_CONFIGURE_FLAGS = \
               --host=$(DEB_HOST_RUST_TYPE) \
               --target=$(DEB_TARGET_RUST_TYPE) \
               --disable-manage-submodules \
               --disable-rustbuild \
               --release-channel=$(RELEASE_CHANNEL) \
               --prefix=/usr

# Use system LLVM (comment out to use vendored LLVM)
OLD_LLVM_VERSION = 3.8
DEB_CONFIGURE_FLAGS += --llvm-root=/usr/lib/llvm-3.9

# Below we detect how we're supposed to bootstrap the stage0 compiler. See
# README.Debian for more details of the cases described below.
#
# Sed expression that matches the "rustc" we have in our Build-Depends field
SED_RUSTC_BUILDDEP := /^Build-Depends:/,/^[^[:space:]\#]/{/\s*rustc.*,/$$action}
PRECONFIGURE_CHECK = :
HAVE_BINARY_TARBALL := $(shell ls -1 dl/*$(DEB_HOST_RUST_TYPE)* 2>/dev/null | wc -l)
# allow not using the binary tarball although it exists
#ifneq (,$(filter $(DEB_HOST_ARCH), amd64 arm64 armhf i386 powerpc ppc64el s390x))
#  HAVE_BINARY_TARBALL := 0
#endif
ifeq (0,$(HAVE_BINARY_TARBALL))
    # Case A (Building from source): the extracted source tree does not include
    # a bootstrapping tarball for the current architecture e.g. because the
    # distro already has a rustc for this arch, or the uploader expects that
    # this requirement be fulfilled in some other way.
    #
    # Case A-1: the builder did not select the "pkg.rustc.dlstage0" build profile.
    # In this case, we use the distro's rustc - either the previous or current version.
    ifeq (,$(findstring pkg.rustc.dlstage0,$(DEB_BUILD_PROFILES)))
        DEB_CONFIGURE_FLAGS += --enable-local-rust --local-rust-root=/usr
    endif
    #
    # Case A-2: the builder selected the "dlstage0" build profile.
    # In this case, the rust build scripts will download a stage0 into dl/ and use that.
    # We don't need to do anything specific in this build file, so this case is empty.
else
    # Case B (Bootstrapping a new distro): the extracted source tree does
    # include a bootstrapping tarball for the current architecture; see the
    # `source_orig-dl` target below on how to build this.
    #
    # In this case, we'll bootstrap from the stage0 given in that tarball.
    # To ensure the uploader of the .dsc didn't make a mistake, we first check
    # that rustc isn't a Build-Depends for the current architecture.
    ifneq (,$(shell action=p; sed -ne "$(SED_RUSTC_BUILDDEP)" debian/control))
    ifeq (,$(shell action=p; sed -ne "$(SED_RUSTC_BUILDDEP)" debian/control | grep '!$(DEB_HOST_ARCH)'))
        PRECONFIGURE_CHECK = $(error found matches for dl/*$(DEB_HOST_RUST_TYPE)*, \
          but rustc might be a Build-Depends for $(DEB_HOST_ARCH))
    endif
    endif
endif

BUILD_DOCS = 1
ifneq (,$(findstring nodoc,$(DEB_BUILD_PROFILES)))
  DEB_CONFIGURE_FLAGS += --disable-docs
  BUILD_DOCS =
endif

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
  DEB_CONFIGURE_FLAGS += --disable-optimize --disable-optimize-cxx --disable-optimize-llvm
endif

# Workaround for powerpc64le: no optimization
# TODO: can remove when https://github.com/rust-lang/rust/issues/39015 is fixed
ifneq (,$(findstring powerpc64le,$(DEB_TARGET_RUST_TYPE)))
  DEB_CONFIGURE_FLAGS += --disable-optimize --disable-optimize-cxx --disable-optimize-llvm
endif


%:
	dh $@ --parallel

# Note: SHELL is not set by dash, but the configure script wants to use it
override_dh_auto_configure:
	# fail the build if we have any instances of OLD_LLVM_VERSION in debian, except for debian/changelog
	! grep --color=always -i 'll...$(OLD_LLVM_VERSION)' --exclude=changelog -R debian
	$(PRECONFIGURE_CHECK)
	SHELL=/bin/sh PATH="$$PWD/debian/bin:$$PATH" DEB_HOST_ARCH="$(DEB_HOST_ARCH)" \
	    ./configure $(DEB_CONFIGURE_FLAGS)

override_dh_auto_clean:
	set -e; \
	if [ -f Makefile ]; then \
	  $(MAKE) clean-all; \
	  $(RM) Makefile config.stamp config.mk; \
	fi
	$(RM) src/rt/hoedown/src/html_blocks.c # clean up after building this ourselves
	$(RM) src/bootstrap/bootstrap.pyc

# upstream bundles this in the source, but in Debian we rebuild everything yo
generate-sources:
	$(MAKE) -C src/rt/hoedown src/html_blocks.c

override_dh_auto_build-arch: generate-sources
	dh_auto_build -- all VERBOSE=1

# note: this is only for buildds that want to do a separate arch:all build;
# there is no point running this yourself "to save time" since it implicitly
# depends on build-arch anyways.
override_dh_auto_build-indep: generate-sources
ifneq (,$(BUILD_DOCS))
	dh_auto_build -- docs VERBOSE=1
endif

override_dh_auto_install:
	dh_auto_install --destdir=$(DEB_DESTDIR)

	mkdir -p $(DEB_DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH)/
	mv $(DEB_DESTDIR)/usr/lib/lib*.so $(DEB_DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH)/

	# Replace duplicated compile-time/run-time dylibs with symlinks
	@set -e; \
	for f in $(DEB_DESTDIR)/usr/lib/rustlib/$(DEB_HOST_RUST_TYPE)/lib/lib*.so; do \
	  name=$${f##*/}; \
	  if [ -f "$(DEB_DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH)/$$name" ]; then \
	    echo "ln -sf ../../../$(DEB_HOST_MULTIARCH)/$$name $$f"; \
	    ln -sf ../../../$(DEB_HOST_MULTIARCH)/$$name $$f; \
	  fi; \
	done

ifneq (,$(BUILD_DOCS))
	# Brute force to remove privacy-breach-logo lintian warning.
	# We could have updated the upstream sources but it would complexify
	# the rebase
	@set -e; \
	find $(DEB_DESTDIR)/usr/share/doc/rust/html -iname '*.html' | \
	while read file; do \
	  topdir=$$(echo "$$file" | sed 's,^$(DEB_DESTDIR)/usr/share/doc/rust/html/,,; s,/[^/]*$$,/,; s,^[^/]*$$,,; s,[^/]\+/,../,g'); \
	  sed -i -e "s,https://doc.rust-lang.org/\(favicon.ico\|logos/rust-logo-32x32-blk.png\),$${topdir}rust-logo-32x32-blk.png," \
              -e "s,https://www.rust-lang.org/\(favicon.ico\|logos/rust-logo-32x32-blk.png\),$${topdir}rust-logo-32x32-blk.png," "$$file"; \
	done
	find $(DEB_DESTDIR) \( -iname '*.html' -empty -o -name .lock -o -name '*.inc' \) -delete
endif

override_dh_install-arch:
	dh_install
	dh_install -p$(LIBSTD_PKG) usr/lib/$(DEB_HOST_MULTIARCH)/

override_dh_install-indep:
	dh_install
	chmod -x \
	  debian/rust-gdb/usr/share/rust-gdb/*.py \
	  debian/rust-lldb/usr/share/rust-lldb/*.py

override_dh_installchangelogs:
	dh_installchangelogs RELEASES.md

override_dh_installdocs:
	dh_installdocs -X.tex -X.aux -X.log -X.out -X.toc

override_dh_compress:
	dh_compress -X.woff

## rustc 1.17.0+dfsg2

=== src/test/run-make/codegen-options-parsing/Makefile ===
-include ../tools.mk

all:
	#Option taking a number
	$(RUSTC) -C codegen-units dummy.rs 2>&1 | \
		grep 'codegen option `codegen-units` requires a number'
	$(RUSTC) -C codegen-units= dummy.rs 2>&1 | \
		grep 'incorrect value `` for codegen option `codegen-units` - a number was expected'
	$(RUSTC) -C codegen-units=foo dummy.rs 2>&1 | \
		grep 'incorrect value `foo` for codegen option `codegen-units` - a number was expected'
	$(RUSTC) -C codegen-units=1 dummy.rs
	#Option taking a string
	$(RUSTC) -C extra-filename dummy.rs 2>&1 | \
		grep 'codegen option `extra-filename` requires a string'
	$(RUSTC) -C extra-filename= dummy.rs 2>&1
	$(RUSTC) -C extra-filename=foo dummy.rs 2>&1
	#Option taking no argument
	$(RUSTC) -C lto= dummy.rs 2>&1 | \
		grep 'codegen option `lto` takes no value'
	$(RUSTC) -C lto=1 dummy.rs 2>&1 | \
		grep 'codegen option `lto` takes no value'
	$(RUSTC) -C lto=foo dummy.rs 2>&1 | \
		grep 'codegen option `lto` takes no value'
	$(RUSTC) -C lto dummy.rs

	# Should not link dead code...
	$(RUSTC) -Z print-link-args dummy.rs 2>&1 | \
		grep -e '--gc-sections' -e '-dead_strip' -e '/OPT:REF'
	# ... unless you specifically ask to keep it
	$(RUSTC) -Z print-link-args -C link-dead-code dummy.rs 2>&1 | \
		(! grep -e '--gc-sections' -e '-dead_strip' -e '/OPT:REF')

=== src/test/run-make/save-analysis/Makefile ===
-include ../tools.mk
all: code
krate2: krate2.rs
	$(RUSTC) $<
code: foo.rs krate2
	$(RUSTC) foo.rs -Zsave-analysis-csv
	$(RUSTC) foo.rs -Zsave-analysis
	$(RUSTC) foo.rs -Zsave-analysis-api

=== debian/changelog ===
rustc (1.17.0+dfsg2-8~ubuntu0.17.04.1) zesty; urgency=medium

  * Backport 1.17.0 to zesty
  * Relax llvm-toolchain-3.9 requirement to 1:3.9.1-4~

 -- Chris Coulson <chris.coulson@canonical.com>  Wed, 19 Jul 2017 18:07:31 +0100

rustc (1.17.0+dfsg2-8) unstable; urgency=medium

  * Workaround for linux #865549, fix FTBFS on ppc64el.

 -- Ximin Luo <infinity0@debian.org>  Mon, 17 Jul 2017 13:41:59 +0200

rustc (1.17.0+dfsg2-7) unstable; urgency=medium

  * Show exception traceback in bootstrap.py to examine ppc64el build failure.

 -- Ximin Luo <infinity0@debian.org>  Wed, 21 Jun 2017 10:46:27 +0200

rustc (1.17.0+dfsg2-6) unstable; urgency=medium

  * Upload to unstable.

 -- Ximin Luo <infinity0@debian.org>  Wed, 21 Jun 2017 00:24:22 +0200

rustc (1.17.0+dfsg2-5) experimental; urgency=medium

  * More work-arounds for armhf test failures.

 -- Ximin Luo <infinity0@debian.org>  Fri, 16 Jun 2017 13:27:45 +0200

rustc (1.17.0+dfsg2-4) experimental; urgency=medium

  * Fix arch-indep and arch-dep tests.
  * Bump the LLVM requirement to fix FTBFS on armhf.

 -- Ximin Luo <infinity0@debian.org>  Wed, 14 Jun 2017 21:37:16 +0200

rustc (1.17.0+dfsg2-3) experimental; urgency=medium

  * Try to force the real gdb package. Some resolvers like aspcud will select
    gdb-minimal under some circumstances, but this causes the debuginfo-gdb
    tests to break.

 -- Ximin Luo <infinity0@debian.org>  Wed, 14 Jun 2017 00:48:37 +0200

rustc (1.17.0+dfsg2-2) experimental; urgency=medium

  * Support and document cross-compiling of rustc itself.
  * Document cross-compiling other rust packages such as cargo.
  * Work around upstream #39015 by disabling those tests rather than by
    disabling optimisation, which causes FTBFS on 1.17.0 ppc64el. See
    upstream #42476 and #42532 for details.

 -- Ximin Luo <infinity0@debian.org>  Tue, 13 Jun 2017 21:13:31 +0200

rustc (1.17.0+dfsg2-1) experimental; urgency=medium

  [ Sylvestre Ledru ]
  * New upstream release

  [ Ximin Luo ]
  * Adapt packaging for rustbuild, the new upstream cargo-based build system.

  [ Matthijs van Otterdijk ]
  * Add a binary package, rust-src. (Closes: #846177)
  * Link to local Debian web resources in the docs, instead of remote ones.

 -- Ximin Luo <infinity0@debian.org>  Tue, 16 May 2017 18:00:53 +0200

rustc (1.16.0+dfsg1-1) unstable; urgency=medium

  * Upload to unstable so we have something to build 1.17 with.
  * Update u-ignoretest-powerpc.patch for 1.16.

 -- Ximin Luo <infinity0@debian.org>  Wed, 19 Apr 2017 22:47:18 +0200

rustc (1.16.0+dfsg1-1~exp2) experimental; urgency=medium

  * Don't ignore test failures on Debian unstable.
  * Re-fix ignoring armhf test, accidentally reverted in previous version.
  * Try to fix buildd failure by swapping B-D alternatives.

 -- Ximin Luo <infinity0@debian.org>  Sun, 16 Apr 2017 15:05:47 +0200

rustc (1.15.1+dfsg1-1) unstable; urgency=medium

  * Upload to unstable so we have something to build 1.16 with.
  * Try to fix ignoring atomic-lock-free tests on armhf.

 -- Ximin Luo <infinity0@debian.org>  Wed, 22 Mar 2017 00:13:27 +0100

=== debian/control ===
--- 
+++ 
@@ -7,20 +7,21 @@
  Sylvestre Ledru <sylvestre@debian.org>,
  Angus Lees <gus@debian.org>,
  Ximin Luo <infinity0@debian.org>
+# Need :native on some of the below for cross-building, because we need to
+# execute them but they're not Multi-Arch: foreign
 Build-Depends: debhelper (>= 9),
                dpkg-dev (>= 1.17.14),
-               rustc (>= 1.15.0+dfsg) <!pkg.rustc.dlstage0>,
-               rustc (<= 1.16.1++) <!pkg.rustc.dlstage0>,
+               python:native,
+               cargo (>= 0.17.0)      <!pkg.rustc.dlstage0>,
+               rustc (>= 1.16.0+dfsg) <!pkg.rustc.dlstage0>,
+               rustc (<= 1.17.0++)    <!pkg.rustc.dlstage0>,
+               llvm-3.9-dev:native   (>= 1:3.9.1-4~),
+               llvm-3.9-tools:native (>= 1:3.9.1-4~),
+               libllvm3.9            (>= 1:3.9.1-4~),
                autotools-dev,
-               binutils-2.26 | binutils (>= 2.26),
-               cmake3 | cmake,
-               curl,
+               cmake | cmake3,
                gperf,
-               libedit-dev,
-               llvm-3.9-dev (>= 1:3.9-5),
-               llvm-3.9-tools (>= 1:3.9-5),
-               python,
-               zlib1g-dev,
+               binutils (>= 2.26) <!nocheck> | binutils-2.26 <!nocheck>,
                nodejs <!nocheck>,
                valgrind <!nocheck>,
                git <!nocheck>,
@@ -31,17 +32,13 @@
                antlr4 <!nocheck> | antlr <!nocheck>,
                bison <!nocheck>,
                flex <!nocheck>,
-# TODO: broken; see https://github.com/rust-lang/rust/issues/39838; re-enable when that is fixed
-#               gdb <!nocheck>,
+               gdb (>= 7.12) <!nocheck>,
                default-jdk-headless <!nocheck> | default-jdk <!nocheck>,
-Build-Depends-Indep: libjs-jquery <!nodoc>,
-                     pandoc (>= 1.9),
-                     po4a,
-                     texlive-xetex,
-                     texlive-latex-base,
-                     texlive-generic-recommended,
-                     texlive-fonts-recommended,
-                     lmodern
+Build-Depends-Indep: libjs-jquery <!nodoc>
+# Work around #864741. The version constraint for gdb above should already do
+# that, but this will keep things covered even in the case that they change
+# gdb-minimal to do a versioned Provides: gdb.
+Build-Conflicts: gdb-minimal <!nocheck>
 Standards-Version: 3.9.8
 Homepage: http://www.rust-lang.org/
 Vcs-Git: https://anonscm.debian.org/git/pkg-rust/rust.git
@@ -54,7 +51,7 @@
 Depends: ${shlibs:Depends}, ${misc:Depends}, libstd-rust-dev (= ${binary:Version}),
  gcc, libc-dev, libjs-jquery, binutils (>= 2.26)
 Recommends: rust-gdb | rust-lldb
-Suggests: rust-doc
+Suggests: rust-doc, rust-src
 Description: Rust systems programming language
  Rust is a curly-brace, block-structured expression language.  It
  visually resembles the C language family, but differs significantly
@@ -68,7 +65,7 @@
  generic programming and meta-programming, in both static and dynamic
  styles.
 
-Package: libstd-rust-1.16
+Package: libstd-rust-1.17
 Section: libs
 Architecture: any
 Multi-Arch: same
@@ -93,7 +90,7 @@
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: ${misc:Depends}, libstd-rust-1.16 (= ${binary:Version})
+Depends: ${misc:Depends}, libstd-rust-1.17 (= ${binary:Version})
 Description: Rust standard libraries - development files
  Rust is a curly-brace, block-structured expression language.  It
  visually resembles the C language family, but differs significantly
@@ -156,7 +153,9 @@
 Section: doc
 Architecture: all
 Build-Profiles: <!nodoc>
-Depends: ${misc:Depends}, libjs-jquery
+Depends: ${misc:Depends},
+ libjs-jquery, libjs-highlight.js, libjs-mathjax,
+ fonts-open-sans, fonts-font-awesome
 Description: Rust systems programming language - Documentation
  Rust is a curly-brace, block-structured expression language.  It
  visually resembles the C language family, but differs significantly
@@ -172,3 +171,23 @@
  .
  This package contains the Rust tutorial, language reference and
  standard library documentation.
+
+Package: rust-src
+Section: devel
+Architecture: all
+Depends: ${misc:Depends}
+Description: Rust systems programming language - source code
+ Rust is a curly-brace, block-structured expression language.  It
+ visually resembles the C language family, but differs significantly
+ in syntactic and semantic details.  Its design is oriented toward
+ concerns of "programming in the large", that is, of creating and
+ maintaining boundaries - both abstract and operational - that
+ preserve large-system integrity, availability and concurrency.
+ .
+ It supports a mixture of imperative procedural, concurrent actor,
+ object-oriented and pure functional styles.  Rust also supports
+ generic programming and meta-programming, in both static and dynamic
+ styles.
+ .
+ This package contains sources of the Rust compiler and standard
+ libraries, useful for IDEs and code analysis tools such as Racer.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

include /usr/share/dpkg/pkg-info.mk
include /usr/share/dpkg/vendor.mk
include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/buildflags.mk
# TODO: more correct to use `[build] rustflags = []` list syntax in Cargo.toml
RUSTFLAGS = $(addprefix -C link-args=,$(LDFLAGS))
export CFLAGS CXXFLAGS CPPFLAGS LDFLAGS RUSTFLAGS

# Defines DEB_*_RUST_TYPE triples
include debian/architecture.mk
export DEB_HOST_RUST_TYPE

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# src/rt/miniz.c (incorrectly) triggers -Wmisleading-indentation with
# gcc-6.  See bug #811573.
CFLAGS += -Wno-misleading-indentation

# Release type (one of beta, stable or nightly)
RELEASE_CHANNEL := stable
# See also ./build-preview-dsc.sh for a script that builds a beta/nightly .dsc
# out of this packaging. Furthermore, if the build breaks after importing a new
# upstream stable release, check the do_temporary_fixup function in that file
# to see if we already know what fix to make.

DEB_DESTDIR := $(CURDIR)/debian/tmp

SED_VERSION_SHORT := sed -re 's/([^.]+)\.([^.]+)\..*/\1.\2/'
RUST_VERSION := $(shell echo '$(DEB_VERSION_UPSTREAM)' | $(SED_VERSION_SHORT))
RUST_LONG_VERSION := $(shell echo '$(DEB_VERSION_UPSTREAM)' | sed -re 's/([^+]+).*/\1/')
LIBSTD_PKG := libstd-rust-$(RUST_VERSION)
# Sed expression that matches the "rustc" we have in our Build-Depends field
SED_RUSTC_BUILDDEP := sed -ne "/^Build-Depends:/,/^[^[:space:]\#]/{/^ *rustc .*,/p}" debian/control

# These are the normal build flags. Upstream is moving to debian/config.toml
# but at the current version not all of these flags are available in that file.
DEB_CONFIGURE_FLAGS = --enable-llvm-link-shared --disable-dist-src --prefix=/usr

# Use system LLVM (comment out to use vendored LLVM)
OLD_LLVM_VERSION = 3.8
DEB_CONFIGURE_FLAGS += --llvm-root=/usr/lib/llvm-3.9
RUSTBUILD = ./x.py
RUSTBUILD_FLAGS = --config debian/config.toml -v

update-version:
	oldver=$(shell $(SED_RUSTC_BUILDDEP) | sed -ne 's/.*(<= \(.*\)).*/\1/gp' | $(SED_VERSION_SHORT)); \
	newver=$(RUST_VERSION); \
	if [ $$oldver != $$newver ]; then debian/update-version.sh $$oldver $$newver; fi

# Below we detect how we're supposed to bootstrap the stage0 compiler. See
# README.Debian for more details of the cases described below.
#
PRECONFIGURE_CHECK = :
HAVE_BINARY_TARBALL := $(shell ls -1 stage0/*/*$(DEB_HOST_RUST_TYPE)* 2>/dev/null | wc -l)
# allow not using the binary tarball although it exists
#ifneq (,$(filter $(DEB_HOST_ARCH), amd64 arm64 armhf i386 powerpc ppc64el s390x))
#  HAVE_BINARY_TARBALL := 0
#endif
ifeq (0,$(HAVE_BINARY_TARBALL))
    # Case A (Building from source): the extracted source tree does not include
    # a bootstrapping tarball for the current architecture e.g. because the
    # distro already has a rustc for this arch, or the uploader expects that
    # this requirement be fulfilled in some other way.
    #
    # Case A-1: the builder did not select the "pkg.rustc.dlstage0" build profile.
    # In this case, we use the distro's rustc - either the previous or current version.
    ifeq (,$(findstring pkg.rustc.dlstage0,$(DEB_BUILD_PROFILES)))
        DEB_CONFIGURE_FLAGS += --enable-local-rust --local-rust-root=/usr
    endif
    #
    # Case A-2: the builder selected the "dlstage0" build profile.
    # In this case, the rust build scripts will download a stage0 into stage0/ and use that.
    # We don't need to do anything specific in this build file, so this case is empty.
else
    # Case B (Bootstrapping a new distro): the extracted source tree does
    # include a bootstrapping tarball for the current architecture; see the
    # `source_orig-stage0` target below on how to build this.
    #
    # In this case, we'll bootstrap from the stage0 given in that tarball.
    # To ensure the uploader of the .dsc didn't make a mistake, we first check
    # that rustc isn't a Build-Depends for the current architecture.
    ifneq (,$(shell $(SED_RUSTC_BUILDDEP)))
    ifeq (,$(shell $(SED_RUSTC_BUILDDEP) | grep '!$(DEB_HOST_ARCH)'))
        PRECONFIGURE_CHECK = $(error found matches for stage0/*/*$(DEB_HOST_RUST_TYPE)*, \
          but rustc might be a Build-Depends for $(DEB_HOST_ARCH))
    endif
    endif
endif

BUILD_DOCS = 1
ifneq (,$(findstring nodoc,$(DEB_BUILD_PROFILES)))
  DEB_CONFIGURE_FLAGS += --disable-docs
  BUILD_DOCS =
endif

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
  DEB_CONFIGURE_FLAGS += --disable-optimize --disable-optimize-cxx --disable-optimize-llvm
endif

# Build products or non-source files in src/, that shouldn't go in rust-src
SRC_CLEAN = src/rt/hoedown/src/html_blocks.c \
	src/bootstrap/bootstrap.pyc \
	src/etc/__pycache__/

# Workaround for linux #865549
ifeq (0,$(shell test $$(uname -s) = "Linux" -a $$(getconf PAGESIZE) -gt 4096; echo $$?))
  SYSTEM_WORKAROUNDS += ulimit -s $$(expr $$(getconf PAGESIZE) / 1024 '*' 256 + 8192);
endif

%:
	$(SYSTEM_WORKAROUNDS) dh $@ --parallel

.PHONY: build
build:
	$(SYSTEM_WORKAROUNDS) dh $@ --parallel

debian/config.toml: debian/config.toml.in
	m4  -DDEB_BUILD_RUST_TYPE="$(DEB_BUILD_RUST_TYPE)" \
		-DDEB_HOST_RUST_TYPE="$(DEB_HOST_RUST_TYPE)" \
		-DDEB_TARGET_RUST_TYPE="$(DEB_TARGET_RUST_TYPE)" \
		-DRELEASE_CHANNEL="$(RELEASE_CHANNEL)" \
		"$<" > "$@"

override_dh_auto_configure: debian/config.toml
	# fail the build if we have any instances of OLD_LLVM_VERSION in debian, except for debian/changelog
	! grep --color=always -i 'll...?$(OLD_LLVM_VERSION)' --exclude=changelog -R debian
	$(PRECONFIGURE_CHECK)
	if [ -d stage0 ]; then mkdir -p build && ln -sfT ../stage0 build/cache; fi
	# work around #842634
	if test $$(grep "127.0.0.1\s*localhost" /etc/hosts | wc -l) -gt 1; then \
	  debian/ensure-patch -N debian/patches/d-host-duplicates.patch; fi
	PATH="$$PWD/debian/bin:$$PATH" \
	    ./configure $(DEB_CONFIGURE_FLAGS)

override_dh_auto_clean:
	$(RM) -rf ./build ./tmp ./.cargo config.stamp config.mk Makefile
	$(RM) -rf $(SRC_CLEAN) debian/config.toml

# upstream bundles this in the source, but in Debian we rebuild everything yo
generate-sources:
	$(MAKE) -C src/rt/hoedown src/html_blocks.c

override_dh_auto_build-arch: generate-sources
	$(RUSTBUILD) build $(RUSTBUILD_FLAGS)

# note: this is only for buildds that want to do a separate arch:all build;
# there is no point running this yourself "to save time" since it implicitly
# depends on build-arch anyways.
override_dh_auto_build-indep: generate-sources
ifneq (,$(BUILD_DOCS))
# Rust has a weird way of configuring whether to build docs or not
	sed -i -e 's/^docs = false/docs = true/' debian/config.toml
	$(RUSTBUILD) doc $(RUSTBUILD_FLAGS)
endif

RUN_TESTS = \
	if $(1); then \
	  : ; \
	elif [ $(DEB_VENDOR) = "Debian" -a $(DEB_DISTRIBUTION) != "experimental" ]; then \
	  false; \
	elif [ $(DEB_VENDOR) = "Ubuntu" -a $(DEB_HOST_ARCH) != "s390x" ]; then \
	  false ; \
	else \
	  echo "====================================================="; \
	  echo "WARNING: Ignoring test failures in the rust testsuite"; \
	  echo "====================================================="; \
	fi

override_dh_auto_test-arch:
ifeq (, $(filter nocheck,$(DEB_BUILD_OPTIONS)))
	$(call RUN_TESTS,RUST_BACKTRACE=1 $(RUSTBUILD) test $(RUSTBUILD_FLAGS))
endif

override_dh_auto_test-indep:
ifneq (,$(BUILD_DOCS))
ifeq (, $(filter nocheck,$(DEB_BUILD_OPTIONS)))
	# Run all rules that test the docs, i.e. in step.rs that depend on default:doc
	$(call RUN_TESTS,RUST_BACKTRACE=1 $(RUSTBUILD) test src/tools/linkchecker $(RUSTBUILD_FLAGS))
endif
endif

override_dh_auto_install:
	DESTDIR=$(DEB_DESTDIR) $(RUSTBUILD) dist $(RUSTBUILD_FLAGS) --install

	mkdir -p $(DEB_DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH)/
	mv $(DEB_DESTDIR)/usr/lib/lib*.so $(DEB_DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH)/

	# Replace duplicated compile-time/run-time dylibs with symlinks
	@set -e; \
	for f in $(DEB_DESTDIR)/usr/lib/rustlib/$(DEB_HOST_RUST_TYPE)/lib/lib*.so; do \
	  name=$${f##*/}; \
